# coding=utf-8
# *** WARNING: this file was generated by pulumi-language-python. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

import builtins
import copy
import warnings
import sys
import pulumi
import pulumi.runtime
from typing import Any, Mapping, Optional, Sequence, Union, overload
if sys.version_info >= (3, 11):
    from typing import NotRequired, TypedDict, TypeAlias
else:
    from typing_extensions import NotRequired, TypedDict, TypeAlias
from . import _utilities

__all__ = [
    'GetCloudAccountResult',
    'AwaitableGetCloudAccountResult',
    'get_cloud_account',
    'get_cloud_account_output',
]

@pulumi.output_type
class GetCloudAccountResult:
    """
    A collection of values returned by getCloudAccount.
    """
    def __init__(__self__, aws_identifiers=None, id=None):
        if aws_identifiers and not isinstance(aws_identifiers, list):
            raise TypeError("Expected argument 'aws_identifiers' to be a list")
        pulumi.set(__self__, "aws_identifiers", aws_identifiers)
        if id and not isinstance(id, str):
            raise TypeError("Expected argument 'id' to be a str")
        pulumi.set(__self__, "id", id)

    @property
    @pulumi.getter(name="awsIdentifiers")
    def aws_identifiers(self) -> Sequence[builtins.str]:
        return pulumi.get(self, "aws_identifiers")

    @property
    @pulumi.getter
    def id(self) -> builtins.str:
        return pulumi.get(self, "id")


class AwaitableGetCloudAccountResult(GetCloudAccountResult):
    # pylint: disable=using-constant-test
    def __await__(self):
        if False:
            yield self
        return GetCloudAccountResult(
            aws_identifiers=self.aws_identifiers,
            id=self.id)


def get_cloud_account(opts: Optional[pulumi.InvokeOptions] = None) -> AwaitableGetCloudAccountResult:
    """
    Use this data source to access information about an existing [Cloud Account](https://docs.controlplane.com/reference/cloudaccount) within Control Plane.

    ## Outputs

    - **aws_identifiers** (String)

    ## Example Usage

    ```python
    import pulumi
    import pulumi_cpln as cpln

    this = cpln.get_cloud_account()
    pulumi.export("cloudAccount", this.aws_identifiers)
    ```
    """
    __args__ = dict()
    opts = pulumi.InvokeOptions.merge(_utilities.get_invoke_opts_defaults(), opts)
    __ret__ = pulumi.runtime.invoke('cpln:index/getCloudAccount:getCloudAccount', __args__, opts=opts, typ=GetCloudAccountResult).value

    return AwaitableGetCloudAccountResult(
        aws_identifiers=pulumi.get(__ret__, 'aws_identifiers'),
        id=pulumi.get(__ret__, 'id'))
def get_cloud_account_output(opts: Optional[Union[pulumi.InvokeOptions, pulumi.InvokeOutputOptions]] = None) -> pulumi.Output[GetCloudAccountResult]:
    """
    Use this data source to access information about an existing [Cloud Account](https://docs.controlplane.com/reference/cloudaccount) within Control Plane.

    ## Outputs

    - **aws_identifiers** (String)

    ## Example Usage

    ```python
    import pulumi
    import pulumi_cpln as cpln

    this = cpln.get_cloud_account()
    pulumi.export("cloudAccount", this.aws_identifiers)
    ```
    """
    __args__ = dict()
    opts = pulumi.InvokeOutputOptions.merge(_utilities.get_invoke_opts_defaults(), opts)
    __ret__ = pulumi.runtime.invoke_output('cpln:index/getCloudAccount:getCloudAccount', __args__, opts=opts, typ=GetCloudAccountResult)
    return __ret__.apply(lambda __response__: GetCloudAccountResult(
        aws_identifiers=pulumi.get(__response__, 'aws_identifiers'),
        id=pulumi.get(__response__, 'id')))
